class IRC_Page extends GUITabPanel
	abstract;

var moEditBox			TextEntry;
var GUIScrollTextBox	TextDisplay;

var localized string HasLeftText;
var localized string HasJoinedText;
var localized string WasKickedByText;
var localized string NowKnownAsText;
var localized string QuitText;
var localized string SetsModeText;

var config int MaxChatScrollback;

// Pure Virtual
function ProcessInput(string Text)
{

}

// When you hit enter in the input box, call the class
function bool InternalOnKeyEvent(out byte Key, out byte State, float delta)
{
	local string Input;

	if( Key == 0x0D ) // ENTER
	{
		Input = TextEntry.GetText();

		if(Input != "")
		{
			ProcessInput(Input); // Handle whatever you typed
			TextEntry.SetText(""); // And empty box again.
		}

		return true;
	}

	return false;
}

function InitComponent(GUIController MyController, GUIComponent MyOwner)
{
	Super.Initcomponent(MyController, MyOwner);

	TextEntry = moEditBox(Controls[0]);
	TextEntry.OnKeyEvent = InternalOnKeyEvent;
	TextEntry.MyEditBox.Style = Controller.GetStyle("IRCEntry"); // Force the style of the sub-component to the IRC text style

	TextDisplay = GUIScrollTextBox( GUIPanel( GUISplitter(Controls[1]).Controls[0] ).Controls[0] );
	TextDisplay.MyScrollText.Separator = Chr(13); // New line character
	TextDisplay.MyScrollText.MaxHistory = MaxChatScrollback;
	TextDisplay.MyScrollText.Style = Controller.GetStyle("IRCText");
}

defaultproperties
{
	Begin Object class=moEditBox Name=EntryBox
		WinWidth=1.0
		WinHeight=0.05
		WinLeft=0
		WinTop=0.95
		CaptionWidth=0
	End Object
	Controls(0)=moEditBox'EntryBox'


	// Scroll box
	Begin Object Class=GUIScrollTextBox Name=DisplayBox
		WinWidth=1.0
		WinHeight=1.0
		WinLeft=0
		WinTop=0
		CharDelay=0.0015
		EOLDelay=0.25
		bVisibleWhenEmpty=true
		bScaleToParent=true
		StyleName="ServerBrowserGrid"
		bNoTeletype=true
		bStripColors=true
	End Object

	// Display panel
	Begin Object Class=GUIPanel Name=DisplayPanel
		Controls(0)=DisplayBox;
	End Object	

	// Util panel
	Begin Object Class=GUIPanel Name=UtilPanel
	End Object

	// Splitter to divide main window in two: server list and details
	Begin Object Class=GUISplitter Name=MainSplitter
		WinWidth=1.0
		WinHeight=0.95
		WinTop=0
		WinLeft=0
		Controls(0)=DisplayPanel
		Controls(1)=UtilPanel
		SplitOrientation=SPLIT_Vertical
		SplitPosition=0.8
		bFixedSplitter=true
	End Object
	Controls(1)=MainSplitter

	WinTop=0.15
	WinLeft=0
	WinWidth=1
	WinHeight=0.73
	bAcceptsInput=false

	MaxChatScrollback=250

	HasLeftText="has left"
	HasJoinedText="has joined"
	WasKickedByText="was kicked by"
	NowKnownAsText="is now known as"
	QuitText="Quit"
	SetsModeText="sets mode"
}